#pragma semicolon 1

#include <sourcemod>
#include <sdktools_functions>

public Plugin:myinfo = 
{
	name	= "AFK Ping Control",
	author	= "wS (World-Source.Ru)",
	version	= "1.3"
};

new Handle:g_hTimer, Handle:g_TimerSec;
new Handle:g_hMaxWarnings;
new Handle:g_hMaxPing;
new Handle:g_hImmunity;

new g_MyPingWarnings[MAXPLAYERS + 1];
new g_MyAfkkWarnings[MAXPLAYERS + 1];
new Float:g_MyAngles[MAXPLAYERS + 1][3];

public OnPluginStart()
{
	g_TimerSec		= CreateConVar("afk_timer",		"20",	"Как часто проверяется пинг и afk (сек)", _, true, 1.0);
	g_hMaxWarnings	= CreateConVar("afk_warnings",	"3",	"Сколько раз нужно не пройти проверку, чтобы отключило с сервера", _, true, 1.0);
	g_hMaxPing		= CreateConVar("afk_max_ping",	"180",	"Максимальный допустимый пинг", _, true, 5.0);
	g_hImmunity		= CreateConVar("afk_immunity",	"1",	"1 = у админов иммунитет, 0 = нет");

	HookConVarChange(g_TimerSec, cvar_changed);
	AutoExecConfig(true, "afk_ping_control", "sourcemod");

	wS_StartTimer();
}

public cvar_changed(Handle:cvar, const String:OldValue[], const String:NewValue[])
{
	if (g_hTimer != INVALID_HANDLE)
	{
		KillTimer(g_hTimer);
		wS_StartTimer();
	}
}

wS_StartTimer()
{
	g_hTimer = CreateTimer(GetConVarFloat(g_TimerSec), g_AfkTimer_CallBack, _, TIMER_REPEAT | TIMER_FLAG_NO_MAPCHANGE);
}

public OnMapStart()
{
	g_hTimer = INVALID_HANDLE;
}

public Action:g_AfkTimer_CallBack(Handle:timer)
{
	new bool:player_found	= false;
	new MaxPing				= GetConVarInt(g_hMaxPing);
	new MaxWarnings			= GetConVarInt(g_hMaxWarnings);
	new bool:Immunity		= GetConVarBool(g_hImmunity);

	decl Float:angles[3];

	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && !IsFakeClient(i))
		{
			player_found = true;

			if (Immunity && GetUserAdmin(i) != INVALID_ADMIN_ID)
			{
				g_MyPingWarnings[i] = 0;
				g_MyAfkkWarnings[i] = 0;
				continue;
			}

			// ping
			if (RoundToZero(GetClientAvgLatency(i, NetFlow_Outgoing) * 1024) > MaxPing)
			{
				if (++g_MyPingWarnings[i] >= MaxWarnings)
				{
					KickClient(i, "Ping Limit: %d", MaxPing);
					continue;
				}
			}
			else
				g_MyPingWarnings[i] = 0;

			// afk
			if (GetClientEyeAngles(i, angles))
			{
				if (angles[0] == g_MyAngles[i][0] && angles[1] == g_MyAngles[i][1] && angles[2] == g_MyAngles[i][2])
				{
					if (++g_MyAfkkWarnings[i] >= MaxWarnings) KickClient(i, "AFK");
				}
				else
					g_MyAngles[i] = angles;
			}
		}
	}

	if (!player_found)
	{
		g_hTimer = INVALID_HANDLE;
		return Plugin_Stop;
	}

	return Plugin_Continue;
}

public OnClientConnected(client)
{
	g_MyPingWarnings[client] = 0;
	g_MyAfkkWarnings[client] = 0;
}

public OnClientPutInServer(client)
{
	if (g_hTimer == INVALID_HANDLE && !IsFakeClient(client))
		wS_StartTimer();
}